function [u] = MES (n)

beta = 2;
gamma = 40;
u1 = 0;

L = zeros(1,n+1);
B = zeros(n+1);

% zapisuje sobie wartosc pochodnych: chi1' i chi2'
chi = [-1 1];

for k=1:n
    xl = (k-1)/n;
    xr = k/n;
    arg = xl + (xr - xl)/2;
    
    a = function_a(arg);
    b = function_b(arg);
    c = function_c(arg);
    f = function_f(arg);
    
    for i=1:2
        
        i1 = k+i-1;
        L(i1) = L(i1) + f/(2*n) + a*u1*chi(i) - b*u1/2 - c*u1*arg/2;
        
        for j=1:2
            
            j1 = k+j-1;
            B(j1, i1) = B(j1, i1) - a*chi(i)*chi(j)*n + b*chi(i)/2 + c/(4*n);
        end
    end   
end    

B(1,1) = B(1,1) - beta;
L(1) = L(1) - gamma;

B(n+1,n) = 0;
B(n, n+1) = 0;

B(n+1, n+1) = 1;
L(n+1) = 0;

X = B \ L';
% macierze L i B gotowe

% robie pseudo pivoting:
wiersz = zeros(1,n+1);
wektor_pr = L';

for i=1:n
    if B(i,i)==0
        k = n+1;
        while B(k,i)==0
            k = k-1;
        end
        wiersz = B(i,:);
        a = wektor_pr(i,1);
        B(i,:) = B(k,:);
        wektor_pr(i,1) = wektor_pr(k,1);
        B(k,:) = wiersz;
        wektor_pr(k,1) = a;
        k = k-1;
    end
end
    
% przepisuje moja macierz (n+1)x(n+1) do (n+1)x3
macierz = zeros(n+1, 3);
wynik = zeros(n+1,1);

for i=2:n
    macierz(i,1) = B(i,i-1);
    macierz(i,2) = B(i,i);
    macierz(i,3) = B(i,i+1);
end

macierz(1,1) = 0;
macierz(1,2) = B(1,1);
macierz(1,3) = B(1,2);

macierz(n+1,1) = B(n+1, n);
macierz(n+1,2) = B(n+1, n+1);
macierz(n+1,3) = 0;

% eliminacja gaussa dla macierzy (n+1)x3 i wektora prawej strony
wektor_pr(1,1) = wektor_pr(1,1)/macierz(1,2);
macierz(1,:) = macierz(1,:)/macierz(1,2);


for k = 2:n+1
    dzielnik = macierz(k,1)/macierz(k-1,2);
    macierz(k,1) = macierz(k,1) - dzielnik * macierz(k-1,2);
    macierz(k,2) = macierz(k,2) - dzielnik * macierz(k-1,3);
    wektor_pr(k,1) = wektor_pr(k,1) - dzielnik * wektor_pr(k-1,1);
    wektor_pr(k,1) = wektor_pr(k,1)/macierz(k,2);
    macierz(k,:) = macierz(k,:)/macierz(k,2);
    
end


% podstawienie odwrotne po eliminacji gaussa
wynik(n+1,1) = wektor_pr(n+1,1);
for k = n:-1:1
    wynik(k,1) = wektor_pr(k,1) - macierz(k,3)*wynik(k+1,1);
end

% tworze macierz punktow funkcji przesuniecia
u = zeros(n+1,1);
for i=1:n+1
    u(i) = u1*(i-1)/n;
end

wynik = wynik + u;   

punkty = [0:1/n:1];
plot(punkty, wynik);

end

function [ a ] = function_a( x )

if x > 0.5
    a = -2;
else
    a = -1;
end

end

function [ b ] = function_b( x )

b = 0;

end

function [ c ] = function_c( x )

c = 0; 

end

function [ f ] = function_f( x )

f = 0;

end